## dm-tree 0.1.8

=== tree/CMakeLists.txt ===
# Version >= 3.12 required for new FindPython module
# https://cmake.org/cmake/help/v3.12/release/3.12.html
cmake_minimum_required (VERSION 3.12)
project (tree LANGUAGES CXX)

# Required for Python.h and python binding.
find_package(Python3 COMPONENTS Interpreter Development)
include_directories(SYSTEM ${Python3_INCLUDE_DIRS})
if(Python3_VERSION VERSION_LESS "3.6.0")
  message(FATAL_ERROR
    "Python found ${Python3_VERSION} < 3.6.0")
endif()

# Use C++14 standard.
set(CMAKE_CXX_STANDARD 14 CACHE STRING "C++ version selection")

# Position-independent code is needed for Python extension modules.
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Set default build type.
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE RELEASE
       CACHE STRING "Choose the type of build: Debug Release."
       FORCE)
endif()
message("Current build type is: ${CMAKE_BUILD_TYPE}")
message("PROJECT_BINARY_DIR is: ${PROJECT_BINARY_DIR}")

if (NOT (WIN32 OR MSVC))
  if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    # Basic build for debugging (default).
    # -Og enables optimizations that do not interfere with debugging.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Og")
  endif()

  if(${CMAKE_BUILD_TYPE} STREQUAL "Release")
    # Optimized release build: turn off debug runtime checks
    # and turn on highest speed optimizations.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG -O3")
  endif()
endif()

if(APPLE)
  # On MacOS:
  #   -undefined dynamic_lookup is necessary for pybind11 linking
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-everything -w -undefined dynamic_lookup")

  # On MacOS, we need this so that CMake will use the right Python if the user
  # has a virtual environment active
  set (CMAKE_FIND_FRAMEWORK LAST)
endif()

# Fetch pybind to be able to use pybind11_add_module symbol.
set(PYBIND_VER v2.10.1)
include(FetchContent)
FetchContent_Declare(
  pybind11
  GIT_REPOSITORY https://github.com/pybind/pybind11
  GIT_TAG        ${PYBIND_VER}
)
if(NOT pybind11_POPULATED)
    FetchContent_Populate(pybind11)
    add_subdirectory(${pybind11_SOURCE_DIR} ${pybind11_BINARY_DIR})
    include_directories(${pybind11_INCLUDE_DIR})
endif()

# Needed to disable Abseil tests.
set (BUILD_TESTING OFF)

# Include abseil-cpp.
set(ABSEIL_VER 20210324.2)
include(ExternalProject)
set(ABSEIL_CMAKE_ARGS
    "-DCMAKE_INSTALL_PREFIX=${CMAKE_SOURCE_DIR}/abseil-cpp"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
    "-DCMAKE_POSITION_INDEPENDENT_CODE=${CMAKE_POSITION_INDEPENDENT_CODE}"
    "-DLIBRARY_OUTPUT_PATH=${CMAKE_SOURCE_DIR}/abseil-cpp/lib")
if(DEFINED CMAKE_OSX_ARCHITECTURES)
    set(ABSEIL_CMAKE_ARGS
        ${ABSEIL_CMAKE_ARGS}
        "-DCMAKE_OSX_ARCHITECTURES=${CMAKE_OSX_ARCHITECTURES}")
endif()
ExternalProject_Add(abseil-cpp
  GIT_REPOSITORY    https://github.com/abseil/abseil-cpp.git
  GIT_TAG           ${ABSEIL_VER}
  PREFIX            ${CMAKE_SOURCE_DIR}/abseil-cpp
  CMAKE_ARGS        ${ABSEIL_CMAKE_ARGS}
)
ExternalProject_Get_Property(abseil-cpp install_dir)
set(abseil_install_dir ${install_dir})
include_directories (${abseil_install_dir}/include)


# Define pybind11 tree module.
pybind11_add_module(_tree tree.h tree.cc)
add_dependencies(_tree abseil-cpp)

if (WIN32 OR MSVC)
    set(ABSEIL_LIB_PREF "absl")
    set(LIB_SUFF "lib")
else()
    set(ABSEIL_LIB_PREF "libabsl")
    set(LIB_SUFF "a")
endif()

# Link abseil static libs.
# We don't use find_library here to force cmake to build abseil before linking.
set(ABSEIL_LIBS int128 raw_hash_set raw_logging_internal strings throw_delegate)
foreach(ABSEIL_LIB IN LISTS ABSEIL_LIBS)
  target_link_libraries(_tree PRIVATE
      "${abseil_install_dir}/lib/${ABSEIL_LIB_PREF}_${ABSEIL_LIB}.${LIB_SUFF}")
endforeach()

# Make the module private to tree package.
set_target_properties(_tree PROPERTIES OUTPUT_NAME tree/_tree)

=== debian/changelog ===
dm-tree (0.1.8-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:45:38 +1100

dm-tree (0.1.8-3build1) noble; urgency=high

  * No change rebuild against libabsl20220623t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 16:55:17 +0100

dm-tree (0.1.8-3) unstable; urgency=low

  * Add patch to resolve circular imports of tree._tree (Closes: #1055686).

 -- Michael Fladischer <fladi@debian.org>  Fri, 19 Jan 2024 20:58:35 +0000

dm-tree (0.1.8-2) unstable; urgency=medium

  * Remove autopkgtest-pkg-pybuild testsuite from d/control. We provide our
    own autopkgtests.

 -- Michael Fladischer <fladi@debian.org>  Mon, 06 Nov 2023 17:45:27 +0000

dm-tree (0.1.8-1) unstable; urgency=low

  * Initial release (Closes: #1042901).

 -- Michael Fladischer <fladi@debian.org>  Wed, 02 Aug 2023 14:10:25 +0000

=== debian/control ===
Source: dm-tree
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Michael Fladischer <fladi@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 libabsl-dev,
 pybind11-dev,
 pybuild-plugin-pyproject,
 python3-absl,
 python3-all,
 python3-all-dev,
 python3-attr,
 python3-numpy,
 python3-pybind11,
 python3-pytest,
 python3-setuptools,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 python3-wrapt,
Standards-Version: 4.6.2
Homepage: https://github.com/deepmind/tree
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-dm-tree
Vcs-Git: https://salsa.debian.org/python-team/packages/python-dm-tree.git
Rules-Requires-Root: no

Package: python-dm-tree-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: library for working with nested data structures (Documentation)
 A library for working with nested data structures. In a way, tree generalizes
 the builtin map function which only supports flat sequences, and allows one to
 apply a function to each "leaf" preserving the overall structure.
 .
 It is backed by an optimized C++ implementation suitable for use in demanding
 applications, such as machine learning models.
 .
 This package contains the documentation.

Package: python3-dm-tree
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: library for working with nested data structures (Python3 version)
 A library for working with nested data structures. In a way, tree generalizes
 the builtin map function which only supports flat sequences, and allows one to
 apply a function to each "leaf" preserving the overall structure.
 .
 It is backed by an optimized C++ implementation suitable for use in demanding
 applications, such as machine learning models.
 .
 This package contains the Python 3 version of the library.

## dm-tree 0.1.9

=== docs/requirements.txt ===
sphinx>=2.0.1
sphinx_rtd_theme>=0.4.3

=== tree/CMakeLists.txt ===
# Version >= 3.24 required for new `FindPython` module and `FIND_PACKAGE_ARGS`
# keyword of `FetchContent` module.
# https://cmake.org/cmake/help/v3.24/release/3.24.html
cmake_minimum_required(VERSION 3.24)

cmake_policy(SET CMP0135 NEW)

project (tree LANGUAGES CXX)

option(USE_SYSTEM_ABSEIL "Force use of system abseil-cpp" OFF)
option(USE_SYSTEM_PYBIND11 "Force use of system pybind11" OFF)

# Required for Python.h and python binding.
find_package(Python3 COMPONENTS Interpreter Development)
include_directories(SYSTEM ${Python3_INCLUDE_DIRS})
if(Python3_VERSION VERSION_LESS "3.6.0")
  message(FATAL_ERROR
    "Python found ${Python3_VERSION} < 3.6.0")
endif()

# Use C++14 standard.
set(CMAKE_CXX_STANDARD 14 CACHE STRING "C++ version selection")

# Position-independent code is needed for Python extension modules.
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Set default build type.
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE RELEASE
       CACHE STRING "Choose the type of build: Debug Release."
       FORCE)
endif()
message("Current build type is: ${CMAKE_BUILD_TYPE}")
message("PROJECT_BINARY_DIR is: ${PROJECT_BINARY_DIR}")

if (NOT (WIN32 OR MSVC))
  if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    # Basic build for debugging (default).
    # -Og enables optimizations that do not interfere with debugging.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Og")
  endif()

  if(${CMAKE_BUILD_TYPE} STREQUAL "Release")
    # Optimized release build: turn off debug runtime checks
    # and turn on highest speed optimizations.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG -O3")
  endif()
endif()

if(APPLE)
  # On MacOS:
  #   -undefined dynamic_lookup is necessary for pybind11 linking
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-everything -w -undefined dynamic_lookup")

  # On MacOS, we need this so that CMake will use the right Python if the user
  # has a virtual environment active
  set (CMAKE_FIND_FRAMEWORK LAST)
endif()

# Use `FetchContent` module to manage all external dependencies (i.e.
# abseil-cpp and pybind11).
include(FetchContent)

# Needed to disable Abseil tests.
set(BUILD_TESTING OFF)

# Try to find abseil-cpp package system-wide first.
if (USE_SYSTEM_ABSEIL)
    message(STATUS "Use system abseil-cpp: ${USE_SYSTEM_ABSEIL}")
    set(ABSEIL_FIND_PACKAGE_ARGS FIND_PACKAGE_ARGS)
endif()

# Include abseil-cpp.
set(ABSEIL_REPO https://github.com/abseil/abseil-cpp)
set(ABSEIL_CMAKE_ARGS
  "-DCMAKE_INSTALL_PREFIX=${CMAKE_SOURCE_DIR}/abseil-cpp"
  "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
  "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
  "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}"
  "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
  "-DCMAKE_POSITION_INDEPENDENT_CODE=${CMAKE_POSITION_INDEPENDENT_CODE}"
  "-DLIBRARY_OUTPUT_PATH=${CMAKE_SOURCE_DIR}/abseil-cpp/lib"
  "-DABSL_PROPAGATE_CXX_STD=ON")
if(DEFINED CMAKE_OSX_ARCHITECTURES)
  set(ABSEIL_CMAKE_ARGS
      ${ABSEIL_CMAKE_ARGS}
      "-DCMAKE_OSX_ARCHITECTURES=${CMAKE_OSX_ARCHITECTURES}")
endif()

FetchContent_Declare(
  absl
  URL         ${ABSEIL_REPO}/archive/refs/tags/20220623.2.tar.gz
  URL_HASH    SHA256=773652c0fc276bcd5c461668dc112d0e3b6cde499600bfe3499c5fdda4ed4a5b
  CMAKE_ARGS  ${ABSEIL_CMAKE_ARGS}
  EXCLUDE_FROM_ALL
  ${ABSEIL_FIND_PACKAGE_ARGS})

# Try to find pybind11 package system-wide first.
if (USE_SYSTEM_PYBIND11)
    message(STATUS "Use system pybind11: ${USE_SYSTEM_PYBIND11}")
    set(PYBIND11_FIND_PACKAGE_ARGS FIND_PACKAGE_ARGS)
endif()

FetchContent_Declare(
  pybind11
  URL       https://github.com/pybind/pybind11/archive/refs/tags/v2.10.1.tar.gz
  URL_HASH  SHA256=111014b516b625083bef701df7880f78c2243835abdb263065b6b59b960b6bad
  ${PYBIND11_FIND_PACKAGE_ARGS})

FetchContent_MakeAvailable(absl pybind11)

# Define pybind11 tree module.
pybind11_add_module(_tree tree.h tree.cc)

target_link_libraries(
  _tree
  PRIVATE
    absl::int128
    absl::raw_hash_set
    absl::raw_logging_internal
    absl::strings
    absl::throw_delegate)

# Make the module private to tree package.
set_target_properties(_tree PROPERTIES OUTPUT_NAME tree/_tree)

=== debian/changelog ===
dm-tree (0.1.9-1build2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:00:39 +0000

dm-tree (0.1.9-1build1) questing; urgency=medium

  * Rebuild against latest abseil

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 01 May 2025 14:27:19 -0400

dm-tree (0.1.9-1) unstable; urgency=low

  * New upstream version 0.1.9
  * Refresh patches.
  * Use dh-sequence-python3.
  * Bump Standards-Version to 4.7.0.
  * Update year in d/copyright.
  * Run wrap-and-sort -bast to reduce diff size of future changes.

 -- Michael Fladischer <fladi@debian.org>  Tue, 25 Feb 2025 08:51:12 +0000

=== debian/rules ===
#! /usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME=dm-tree

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

execute_before_dh_sphinxdoc:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	cd $$(pybuild --print build_dir --name dm-tree |head -n1 |awk -F ': ' '{print $$2}'); python3 -m sphinx -b html -N $(CURDIR)/docs $(CURDIR)/debian/python-dm-tree-doc/usr/share/doc/python-dm-tree-doc/html
endif

=== debian/tests/control ===
Tests:
 upstream,
Depends:
 python3-all,
 @,
 @builddeps@,
Restrictions:
 allow-stderr,
